----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:38:31 03/04/2008 
-- Design Name: 
-- Module Name:    one_hundred_K_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

-- Eingangstakt 50 MHz; Ausgabe 1Hz, 10Hz, 100Hz
entity clkdivider is
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC; -- active low
			  dout_1Hz : out STD_LOGIC; 
           dout_10Hz : out STD_LOGIC; 
           dout_100Hz : out  STD_LOGIC
			  );
end clkdivider;

architecture Behavioral of clkdivider is

signal count0 : std_logic_vector (3 downto 0) := (others=>'0');
signal count1 : std_logic_vector (3 downto 0) := (others=>'0');
signal count2 : std_logic_vector (25 downto 0) := (others=>'0');




signal co1Hz : std_logic := '1';
signal co10Hz : std_logic := '0';
signal co100Hz : std_logic := '0';
begin



process (clk, rst)
begin
if (rst='0') then
  count2 <= (others=>'0');
  elsif (clk'event and clk='1') then
     if (count2 = x"7A120") then 
			  count2 <= (others=>'0');
			  co100Hz <= '1';
	  elsif (count2 = x"3D090") then -- if count = 49,999 then 
			count2 <= count2+1;
			co100Hz <= '0';
	  else count2 <= count2+1;
	  end if;
end if;
end process;

process (co100Hz, rst)
begin
if (rst='0') then
  count1 <= (others=>'0');
  elsif (co100Hz'event and co100Hz='1') then
  if (count1 = x"A") then 
			  count1 <= (others=>'0');
			  co10Hz <= '1';
   elsif (count1 = x"5") then  
			count1 <= count1+1;
			co10Hz <= '0';
	else count1 <= count1+1;
	end if;
end if;
end process;

process (co10Hz, rst)
begin
if (rst='0') then
  count0 <= (others=>'0');
  elsif (co10Hz'event and co10Hz='1') then
     if (count0 = x"A") then 
			  count0 <= (others=>'0');
			  co1Hz <= '1';
		  elsif (count0 = x"A") then -- if count = 49,999 then 
			count0 <= count0+1;
			co1Hz <= '0';
			 else count0 <= count0+1;
		  end if;
end if;
end process;

dout_1Hz <= co1Hz;
dout_10Hz <= co10Hz;
dout_100Hz <= co100Hz;


end Behavioral;

